/*
 * test1.cpp
 *  This is the simplest possible program using bbTablet.
 *  This program demonstrates how easy it is to get going right away adding
 *  tablet support to your own apps.
 *  
 *  Just call initSystem() with an HWND once at the beginning,
 *  then call getNextEvent whenever you want to poll for more events.
 *  
 *  
 *  LICENSE:
 *  I place this sample code in the PUBLIC DOMAIN
 */
#include "bbtablet.h"
#include "stopwatch.hpp"
#include <windows.h>
#include <stdio.h>



int main(int argc, char* argv[])
{
  //HWND wnd = GetDesktopWindow();
  HWND wnd = GetForegroundWindow();
  long lostPackets=0;

  bbTabletDevice &td = bbTabletDevice::getInstance( );
  //td.initTablet( wnd, bbTabletDevice::SYSTEM_POINTER );
  td.initTablet( wnd, bbTabletDevice::SEPARATE_POINTER );

  bbTabletEvent evt;
  Stopwatch g_hzTimer;
  g_hzTimer.Start();
  unsigned int npackets = 0;

  while (true) {

    if (!td.getNextEvent(evt))
      continue;

    if (lostPackets = td.getNumDroppedEvents()) {
      printf("LOST %ld EVENTS!\n", lostPackets);
      npackets += lostPackets;
      td.resetNumDroppedEvents();
    }
    npackets++;

#if 1
    printf("id=%x dev=%d type=%d b=%x (%0.3f, %0.3f, %0.3f) p=%0.3f tp=%0.3f (%d,%d)\n", 
           evt.id,
           evt.deviceID,
           evt.type,
           evt.buttons,
           evt.x,
           evt.y,
           evt.z,
           evt.pressure,
           evt.tpressure,
           //evt.getRawX(),
           //evt.getRawY()
           evt.getWinX(),
           evt.getWinY()
           );
          //evt.angle
          //evt.axis[3]
#else
    float t = g_hzTimer.GetTime();
    if (t>1.0) {
      printf("Measured report rate = %0.1f\n", npackets/t);
      g_hzTimer.Reset();
      npackets = 0;
    }
#endif

#if 0
    printf("  Cursor name: %s\n", td.getCursorName(evt.type));
    for( int b=0; evt.buttons != 0; evt.buttons>>=1, b++)
    {
      if (evt.buttons & 1)
        printf("  Btn name %d: %s\n", b, td.getCursorButtonName(evt.type, b));
    }
#endif

#if 0
  // test switching back and forth between system pointer
  // and separate pointer mode.
  static int cnt=0;
    if (!(++cnt%100)) {
     td.setPointerMode(
      ((cnt/100)%2)==1?
      bbTabletDevice::SEPARATE_POINTER:
      bbTabletDevice::SYSTEM_POINTER);
    }
#endif
  }
  return 0;
}
